]> git.ipfire.org Git - thirdparty/git.git/blame - git-fetch.sh
Merge branch 'jc/diff-stat'
[thirdparty/git.git] / git-fetch.sh
CommitLineData
7ef76925
LT
1#!/bin/sh
2#
87358b7a
FK
3
4USAGE='<fetch-options> <repository> <refspec>...'
ae2b0f15 5. git-sh-setup
215a7ad1 6. git-parse-remote
853a3697
JH
7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
9
221e743c
JH
10LF='
11'
12IFS="$LF"
13
55b7835e 14rloga=fetch
03febf99 15no_tags=
ed1aadf1 16tags=
853a3697 17append=
ae2da406 18force=
583122cd 19verbose=
b10ac50f 20update_head_ok=
2c620a1a 21exec=
96b086d6 22upload_pack=
482faa8d 23keep=--thin
ae2da406
JH
24while case "$#" in 0) break ;; esac
25do
26 case "$1" in
27 -a|--a|--ap|--app|--appe|--appen|--append)
28 append=t
ae2da406 29 ;;
2796a9de
JH
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
2c620a1a
MO
32 shift
33 exec="--exec=$1"
96b086d6 34 upload_pack="-u $1"
2c620a1a 35 ;;
ae2da406
JH
36 -f|--f|--fo|--for|--forc|--force)
37 force=t
b10ac50f 38 ;;
ed1aadf1
LT
39 -t|--t|--ta|--tag|--tags)
40 tags=t
41 ;;
03febf99
JH
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 no_tags=t
44 ;;
b10ac50f
JH
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
48 update_head_ok=t
ae2da406 49 ;;
583122cd
LT
50 -v|--verbose)
51 verbose=Yes
52 ;;
0f76f526
TP
53 -k|--k|--ke|--kee|--keep)
54 keep=--keep
55 ;;
55b7835e
SP
56 --reflog-action=*)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
58 ;;
87358b7a
FK
59 -*)
60 usage
61 ;;
ae2da406
JH
62 *)
63 break
64 ;;
65 esac
b10ac50f 66 shift
ae2da406
JH
67done
68
853a3697
JH
69case "$#" in
700)
648ad18f
SB
71 origin=$(get_default_remote)
72 test -n "$(get_remote_url ${origin})" ||
73 die "Where do you want to fetch from today?"
74 set x $origin ; shift ;;
853a3697 75esac
ae2da406 76
853a3697
JH
77remote_nick="$1"
78remote=$(get_remote_url "$@")
79refs=
80rref=
81rsync_slurped_objects=
82
55b7835e 83rloga="$rloga $remote_nick"
ed0e078f 84test "$remote_nick" = "$remote" || rloga="$rloga $remote"
55b7835e 85
853a3697
JH
86if test "" = "$append"
87then
df34297a 88 : >"$GIT_DIR/FETCH_HEAD"
853a3697
JH
89fi
90
91append_fetch_head () {
92 head_="$1"
93 remote_="$2"
94 remote_name_="$3"
95 remote_nick_="$4"
96 local_name_="$5"
05dd8e2e
JH
97 case "$6" in
98 t) not_for_merge_='not-for-merge' ;;
99 '') not_for_merge_= ;;
100 esac
853a3697 101
06ec2b4b
JH
102 # remote-nick is the URL given on the command line (or a shorthand)
103 # remote-name is the $GIT_DIR relative refs/ path we computed
104 # for this refspec.
687b8be8
EW
105
106 # the $note_ variable will be fed to git-fmt-merge-msg for further
107 # processing.
06ec2b4b
JH
108 case "$remote_name_" in
109 HEAD)
110 note_= ;;
111 refs/heads/*)
112 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
b91fb518 113 note_="branch '$note_' of " ;;
06ec2b4b
JH
114 refs/tags/*)
115 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
b91fb518 116 note_="tag '$note_' of " ;;
687b8be8
EW
117 refs/remotes/*)
118 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
119 note_="remote branch '$note_' of " ;;
06ec2b4b 120 *)
b91fb518 121 note_="$remote_name of " ;;
06ec2b4b 122 esac
f327dbce 123 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
b91fb518
JH
124 remote_="$remote_1_"
125 note_="$note_$remote_"
06ec2b4b 126
853a3697
JH
127 # 2.6.11-tree tag would not be happy to be fed to resolve.
128 if git-cat-file commit "$head_" >/dev/null 2>&1
129 then
8572aa85 130 headc_=$(git-rev-parse --verify "$head_^0") || exit
df34297a 131 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
132 [ "$verbose" ] && echo >&2 "* committish: $head_"
133 [ "$verbose" ] && echo >&2 " $note_"
853a3697 134 else
df34297a 135 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
136 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
137 [ "$verbose" ] && echo >&2 " $note_"
853a3697
JH
138 fi
139 if test "$local_name_" != ""
140 then
141 # We are storing the head locally. Make sure that it is
142 # a fast forward (aka "reverse push").
06ec2b4b 143 fast_forward_local "$local_name_" "$head_" "$note_"
853a3697
JH
144 fi
145}
146
147fast_forward_local () {
866ff2f7 148 mkdir -p "$(dirname "$GIT_DIR/$1")"
853a3697
JH
149 case "$1" in
150 refs/tags/*)
151 # Tags need not be pointing at commits so there
152 # is no way to guarantee "fast-forward" anyway.
ae2da406
JH
153 if test -f "$GIT_DIR/$1"
154 then
f8765797
JH
155 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
156 then
7eae7b99 157 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
f8765797
JH
158 else
159 echo >&2 "* $1: updating with $3"
55b7835e 160 git-update-ref -m "$rloga: updating tag" "$1" "$2"
f8765797 161 fi
ae2da406 162 else
06ec2b4b 163 echo >&2 "* $1: storing $3"
55b7835e 164 git-update-ref -m "$rloga: storing tag" "$1" "$2"
ae2da406 165 fi
bf7960eb 166 ;;
ae2da406 167
687b8be8 168 refs/heads/* | refs/remotes/*)
bf7960eb
JH
169 # $1 is the ref being updated.
170 # $2 is the new value for the ref.
171 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
172 if test "$local"
33b83034 173 then
bf7960eb 174 # Require fast-forward.
853a3697
JH
175 mb=$(git-merge-base "$local" "$2") &&
176 case "$2,$mb" in
177 $local,*)
ea5aeb07
JH
178 if test -n "$verbose"
179 then
180 echo >&2 "* $1: same as $3"
181 fi
853a3697
JH
182 ;;
183 *,$local)
06ec2b4b 184 echo >&2 "* $1: fast forward to $3"
9d7f73d4 185 echo >&2 " from $local to $2"
55b7835e 186 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
853a3697
JH
187 ;;
188 *)
189 false
190 ;;
191 esac || {
06ec2b4b 192 echo >&2 "* $1: does not fast forward to $3;"
bf7960eb
JH
193 case ",$force,$single_force," in
194 *,t,*)
06ec2b4b 195 echo >&2 " forcing update."
55b7835e 196 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
ae2da406
JH
197 ;;
198 *)
bf7960eb 199 echo >&2 " not updating."
a9698bb2 200 exit 1
ae2da406
JH
201 ;;
202 esac
853a3697
JH
203 }
204 else
bf7960eb 205 echo >&2 "* $1: storing $3"
55b7835e 206 git-update-ref -m "$rloga: storing head" "$1" "$2"
33b83034 207 fi
0a623e7c 208 ;;
853a3697
JH
209 esac
210}
211
b10ac50f
JH
212case "$update_head_ok" in
213'')
bf7960eb 214 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
215 ;;
216esac
217
ed1aadf1
LT
218# If --tags (and later --heads or --all) is specified, then we are
219# not talking about defaults stored in Pull: line of remotes or
220# branches file, and just fetch those and refspecs explicitly given.
221# Otherwise we do what we always did.
222
223reflist=$(get_remote_refs_for_fetch "$@")
224if test "$tags"
225then
878ccb26 226 taglist=`IFS=" " &&
57a39690
JH
227 (
228 git-ls-remote $upload_pack --tags "$remote" ||
229 echo fail ouch
230 ) |
81214e4d
JH
231 while read sha1 name
232 do
57a39690
JH
233 case "$sha1" in
234 fail)
235 exit 1
236 esac
81214e4d 237 case "$name" in
878ccb26 238 *^*) continue ;;
81214e4d
JH
239 esac
240 if git-check-ref-format "$name"
241 then
242 echo ".${name}:${name}"
243 else
244 echo >&2 "warning: tag ${name} ignored"
245 fi
57a39690 246 done` || exit
ed1aadf1
LT
247 if test "$#" -gt 1
248 then
249 # remote URL plus explicit refspecs; we need to merge them.
221e743c 250 reflist="$reflist$LF$taglist"
ed1aadf1
LT
251 else
252 # No explicit refspecs; fetch tags only.
253 reflist=$taglist
254 fi
255fi
256
03febf99
JH
257fetch_main () {
258 reflist="$1"
259 refs=
4839bd8a 260 rref=
f170e4b3 261
03febf99
JH
262 for ref in $reflist
263 do
264 refs="$refs$LF$ref"
f170e4b3 265
03febf99
JH
266 # These are relative path from $GIT_DIR, typically starting at refs/
267 # but may be HEAD
f327dbce 268 if expr "z$ref" : 'z\.' >/dev/null
03febf99
JH
269 then
270 not_for_merge=t
f327dbce 271 ref=$(expr "z$ref" : 'z\.\(.*\)')
03febf99
JH
272 else
273 not_for_merge=
274 fi
dfdcb558 275 if expr "z$ref" : 'z+' >/dev/null
03febf99
JH
276 then
277 single_force=t
dfdcb558 278 ref=$(expr "z$ref" : 'z+\(.*\)')
03febf99
JH
279 else
280 single_force=
281 fi
f327dbce
MW
282 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
283 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
853a3697 284
03febf99 285 rref="$rref$LF$remote_name"
4447badc 286
03febf99
JH
287 # There are transports that can fetch only one head at a time...
288 case "$remote" in
38529e28 289 http://* | https://* | ftp://*)
03febf99
JH
290 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
291 curl_extra_args="-k"
292 fi
3ea099d4
SK
293 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
294 "`git-repo-config --bool http.noEPSV`" = true ]; then
295 noepsv_opt="--disable-epsv"
296 fi
093b0688
NH
297 max_depth=5
298 depth=0
299 head="ref: $remote_name"
300 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
301 do
d9bffc08 302 remote_name_quoted=$(@@PERL@@ -e '
03febf99 303 my $u = $ARGV[0];
093b0688 304 $u =~ s/^ref:\s*//;
03febf99
JH
305 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
306 print "$u";
093b0688 307 ' "$head")
3ea099d4 308 head=$(curl -nsfL $curl_extra_args $noepsv_opt "$remote/$remote_name_quoted")
093b0688
NH
309 depth=$( expr \( $depth + 1 \) )
310 done
f327dbce 311 expr "z$head" : "z$_x40\$" >/dev/null ||
093b0688 312 die "Failed to fetch $remote_name from $remote"
03febf99
JH
313 echo >&2 Fetching "$remote_name from $remote" using http
314 git-http-fetch -v -a "$head" "$remote/" || exit
315 ;;
316 rsync://*)
317 TMP_HEAD="$GIT_DIR/TMP_HEAD"
318 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
319 head=$(git-rev-parse --verify TMP_HEAD)
320 rm -f "$TMP_HEAD"
321 test "$rsync_slurped_objects" || {
322 rsync -av --ignore-existing --exclude info \
323 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
853a3697 324
03febf99
JH
325 # Look at objects/info/alternates for rsync -- http will
326 # support it natively and git native ones will do it on
327 # the remote end. Not having that file is not a crime.
328 rsync -q "$remote/objects/info/alternates" \
329 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
330 rm -f "$GIT_DIR/TMP_ALT"
331 if test -f "$GIT_DIR/TMP_ALT"
332 then
333 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
334 while read alt
335 do
336 case "$alt" in 'bad alternate: '*) die "$alt";; esac
337 echo >&2 "Getting alternate: $alt"
338 rsync -av --ignore-existing --exclude info \
339 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
340 done
341 rm -f "$GIT_DIR/TMP_ALT"
342 fi
343 rsync_slurped_objects=t
344 }
345 ;;
346 *)
347 # We will do git native transport with just one call later.
348 continue ;;
349 esac
f170e4b3 350
03febf99
JH
351 append_fetch_head "$head" "$remote" \
352 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
853a3697 353
03febf99
JH
354 done
355
356 case "$remote" in
38529e28 357 http://* | https://* | ftp://* | rsync://* )
03febf99
JH
358 ;; # we are already done.
359 *)
360 ( : subshell because we muck with IFS
361 IFS=" $LF"
362 (
482faa8d 363 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
03febf99
JH
364 ) |
365 while read sha1 remote_name
366 do
367 case "$sha1" in
368 failed)
369 echo >&2 "Fetch failure: $remote"
370 exit 1 ;;
371 esac
372 found=
373 single_force=
374 for ref in $refs
375 do
376 case "$ref" in
377 +$remote_name:*)
378 single_force=t
379 not_for_merge=
380 found="$ref"
381 break ;;
382 .+$remote_name:*)
383 single_force=t
384 not_for_merge=t
385 found="$ref"
386 break ;;
387 .$remote_name:*)
388 not_for_merge=t
389 found="$ref"
390 break ;;
391 $remote_name:*)
392 not_for_merge=
393 found="$ref"
394 break ;;
395 esac
396 done
f327dbce 397 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
03febf99
JH
398 append_fetch_head "$sha1" "$remote" \
399 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
400 done
401 ) || exit ;;
402 esac
403
404}
405
406fetch_main "$reflist"
407
408# automated tag following
409case "$no_tags$tags" in
410'')
6dc78e69
JH
411 case "$reflist" in
412 *:refs/*)
413 # effective only when we are following remote branch
414 # using local tracking branch.
415 taglist=$(IFS=" " &&
416 git-ls-remote $upload_pack --tags "$remote" |
417 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
418 while read sha1 name
419 do
420 test -f "$GIT_DIR/$name" && continue
421 git-check-ref-format "$name" || {
422 echo >&2 "warning: tag ${name} ignored"
423 continue
424 }
425 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
426 echo >&2 "Auto-following $name"
427 echo ".${name}:${name}"
428 done)
429 esac
03febf99
JH
430 case "$taglist" in
431 '') ;;
432 ?*)
433 fetch_main "$taglist" ;;
434 esac
853a3697 435esac
b10ac50f
JH
436
437# If the original head was empty (i.e. no "master" yet), or
438# if we were told not to worry, we do not have to check.
439case ",$update_head_ok,$orig_head," in
440*,, | t,* )
441 ;;
442*)
bf7960eb 443 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
444 if test "$curr_head" != "$orig_head"
445 then
55b7835e
SP
446 git-update-ref \
447 -m "$rloga: Undoing incorrectly fetched HEAD." \
448 HEAD "$orig_head"
b10ac50f
JH
449 die "Cannot fetch into the current branch."
450 fi
451 ;;
452esac